#
# Copyright (c) 2004-2005 Linuxant inc.
#
# NOTE: The use and distribution of this software is governed by the terms in
# the file LICENSE, which is included in the package. You must read this and
# agree to these terms before using or distributing this software.
#

%define with_ssl	no

%define dldrabbr    dldr
%define dldrsbindir /usr/sbin
%define dldretcdir  /etc/driverloader
%define version     0.2.3.0

%define name	%{dldrabbr}_wpa_supplicant

%if "%{is_generic}" == "yes"
	%define release	1generic
%else
	%define release	1
%endif

%define website	http://hostap.epitest.fi/wpa_supplicant/


Summary:	A WPA Supplicant for Linux with support for WPA-PSK ("WPA-Personal").
Name:		%{name}
Version:	%{version}
Release:	%{release}
Group:		System Environment/Kernel
Copyright:	GPL/BSD/Copyright (c) 2004 Linuxant inc. All rights reserved.
URL:		%{website}
Vendor:		Jouni Malinen <jkmaline@cc.hut.fi>
Source:		%{website}/%{name}-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Packager:	Linuxant Inc.

# Do not let RPM define dependencies on certains versions of glibc
AutoReqProv: no

%description
A WPA Supplicant for Linux with support for WPA-PSK ("WPA-Personal"). Compiled for DriverLoader.

%prep
%setup -q -n %{name}-%{version}


%build
%if "%{is_generic}" == "yes"
	make tardist
	make %{dldrabbr}wpaconfig
%else
	%if "%{with_ssl}" == "yes"
		make with_ssl=yes bindist %{dldrabbr}wpaconfig
	%else
		make bindist %{dldrabbr}wpaconfig
	%endif
%endif


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

PWD_BUILD="`pwd`"
mkdir -p $RPM_BUILD_ROOT/%{dldrsbindir}
mkdir -p $RPM_BUILD_ROOT//usr/lib/dldr_wpa_supplicant-0.2.3.0/src/
install -m 700 %{dldrabbr}wpaconfig $RPM_BUILD_ROOT/%{dldrsbindir}/

%if "%{is_generic}" == "yes"
	cd $RPM_BUILD_ROOT//usr/lib/dldr_wpa_supplicant-0.2.3.0/src/.. && rmdir src && tar -xzf $PWD_BUILD/packages/%{name}-%{version}.tar.gz && mv %{name}-%{version} src
%else
	mkdir -p $RPM_BUILD_ROOT//usr/lib/dldr_wpa_supplicant-0.2.3.0/src
	# Copy the glibc-2.3 binaries we just built on this system
	mv ${PWD_BUILD}/binaries $RPM_BUILD_ROOT//usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries
	
	# Copy the glibc-2.2 binaries from the Debian system if they are available
	if [ -d /debian/products/%{name}/%{name}-%{version}/binaries/glibc-2.2 ]; then
		cp -r /debian/products/%{name}/%{name}-%{version}/binaries/glibc-2.2 $RPM_BUILD_ROOT//usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries/glibc-2.2
	fi

	# Default config file
	mkdir -p $RPM_BUILD_ROOT/%{dldretcdir}
	install -m 600 $PWD_BUILD/wpa_supplicant.conf $RPM_BUILD_ROOT/%{dldretcdir}/%{dldrabbr}_wpa_supplicant.conf

	# glibcver script needed when installing the package
	install -m 700 $PWD_BUILD/glibcver $RPM_BUILD_ROOT//usr/lib/dldr_wpa_supplicant-0.2.3.0/src
%endif


%clean 
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


%post
%if "%{is_generic}" == "no"
	# Generate the symlinks to the right version of the binaries
	GLIBCVER="`/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/glibcver`"

	if [ -d "/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries/glibc-${GLIBCVER}" ]; then
		ln -s "/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries/glibc-${GLIBCVER}/%{dldrabbr}_wpa_supplicant" %{dldrsbindir}/%{dldrabbr}_wpa_supplicant
		ln -s "/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries/glibc-${GLIBCVER}/%{dldrabbr}_wpa_passphrase" %{dldrsbindir}/%{dldrabbr}_wpa_passphrase
		ln -s "/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries/glibc-${GLIBCVER}/%{dldrabbr}_wpa_cli" %{dldrsbindir}/%{dldrabbr}_wpa_cli
%if "%{with_ssl}" == "yes"
		ln -s "/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries/glibc-${GLIBCVER}/%{dldrabbr}_eapol_test" %{dldrsbindir}/%{dldrabbr}_eapol_test
%endif
	else
		echo "This package doesn't support glibc version '${GLIBCVER}', please remove"
		echo "this package and try with the generic package instead."
		exit 1
	fi
%endif

	echo "Please run the '%{dldrsbindir}/%{dldrabbr}wpaconfig' command in a root shell to complete the"
	echo "installation."

%preun
%if "%{is_generic}" == "yes"
	cd /usr/lib/dldr_wpa_supplicant-0.2.3.0/src
	make uninstall distclean > /dev/null 2>&1

	# Some files will be deleted by the "make uninstall distclean" command and they are expected to be there
	# by the RPM tool, so a warning about a missing files will be generated by some
	# versions of the RPM tool. We add fake files here to solve this issue.
	touch /usr/lib/dldr_wpa_supplicant-0.2.3.0/src/dldr_wpa_supplicant.spec
	touch %{dldrsbindir}/%{dldrabbr}wpaconfig
%else
	rm -f %{dldrsbindir}/%{dldrabbr}_wpa_supplicant
	rm -f %{dldrsbindir}/%{dldrabbr}_wpa_passphrase
	rm -f %{dldrsbindir}/%{dldrabbr}_wpa_cli
%if "%{with_ssl}" == "yes"
	rm -f %{dldrsbindir}/%{dldrabbr}_wpa_eapol_test
%endif
%endif


%files

%{dldrsbindir}/%{dldrabbr}wpaconfig

%dir /usr/lib/dldr_wpa_supplicant-0.2.3.0/src/..
%dir /usr/lib/dldr_wpa_supplicant-0.2.3.0/src

%if "%{is_generic}" == "yes"
	%defattr(0644,root,root)
	/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/*
	/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/.config
	/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/.cvsignore
%else
	%dir /usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries
	%doc ChangeLog COPYING developer.txt eap_testing.txt README README.Linuxant todo.txt LICENSE
	%defattr(0500,root,root)
	/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/../binaries/*

	%defattr(0600,root,root)
	%{dldretcdir}/%{dldrabbr}_wpa_supplicant.conf

	%defattr(0700,root,root)
	/usr/lib/dldr_wpa_supplicant-0.2.3.0/src/glibcver
%endif

# The changelog tag must be last since we will append it to this file
%changelog

* Sun Jun 20 2004 - v0.2.3
	* sort scan results to improve AP selection
	* fixed control interface socket removal for some error cases
	* improved scan requesting and authentication timeout
	* small improvements/bug fixes for EAP-MSCHAPv2, EAP-PEAP, and
	  TLS processing
	* PEAP version can now be forced with phase1="peapver=<ver>"
	  (mostly for testing; by default, the highest version supported by
	  both the Supplicant and Authentication Server is selected
	  automatically)
	* added support for madwifi driver (Atheros ar521x)
	* added a workaround for cases where AP sets Install Tx/Rx bit for
	  WPA Group Key messages when pairwise keys are used (without this,
	  the Group Key would be used for Tx and the AP would drop frames
	  from the station)
	* added GSM SIM/USIM interface for GSM authentication algorithm for
	  EAP-SIM; this requires pcsc-lite
	* added support for ATMEL AT76C5XXx driver
	* fixed IEEE 802.1X WEP key derivation in the case where Authenticator
	  does not include key data in the EAPOL-Key frame (i.e., part of
	  EAP keying material is used as data encryption key)
	* added support for using plaintext and static WEP networks
	  (key_mgmt=NONE)

* Mon May 31 2004 - v0.2.2
	* added support for new EAP authentication methods:
	  EAP-TTLS/EAP-MD5-Challenge
	  EAP-TTLS/EAP-GTC
	  EAP-TTLS/EAP-MSCHAPv2
	  EAP-TTLS/EAP-TLS
	  EAP-TTLS/MSCHAPv2
	  EAP-TTLS/MSCHAP
	  EAP-TTLS/PAP
	  EAP-TTLS/CHAP
	  EAP-PEAP/TLS
	  EAP-PEAP/GTC
	  EAP-PEAP/MD5-Challenge
	  EAP-GTC
	  EAP-SIM (not yet complete; needs GSM/SIM authentication interface)
	* added support for anonymous identity (to be used when identity is
	  sent in plaintext; real identity will be used within TLS protected
	  tunnel (e.g., with EAP-TTLS)
	* added event messages from wpa_supplicant to frontends, e.g., wpa_cli
	* added support for requesting identity and password information using
	  control interface; in other words, the password for EAP-PEAP or
	  EAP-TTLS does not need to be included in the configuration file since
	  a frontand (e.g., wpa_cli) can ask it from the user
	* improved RSN pre-authentication to use a candidate list and process
	  all candidates from each scan; not only one per scan
	* fixed RSN IE and WPA IE capabilities field parsing
	* ignore Tx bit in GTK IE when Pairwise keys are used
	* avoid making new scan requests during IEEE 802.1X negotiation
	* use openssl/libcrypto for MD5 and SHA-1 when compiling wpa_supplicant
	  with TLS support (this replaces the included implementation with
	  library code to save about 8 kB since the library code is needed
	  anyway for TLS)
	* fixed WPA-PSK only mode when compiled without IEEE 802.1X support
	  (i.e., without CONFIG_IEEE8021X_EAPOL=y in .config)

* Thu May 06 2004 - v0.2.1
	* added support for internal IEEE 802.1X (actually, IEEE 802.1aa/D6.1)
	  Supplicant
	  - EAPOL state machines for Supplicant [IEEE 802.1aa/D6.1]
	  - EAP peer state machine [draft-ietf-eap-statemachine-02.pdf]
	  - EAP-MD5 (cannot be used with WPA-RADIUS)
	    [draft-ietf-eap-rfc2284bis-09.txt]
	  - EAP-TLS [RFC 2716]
	  - EAP-MSCHAPv2 (currently used only with EAP-PEAP)
	  - EAP-PEAP/MSCHAPv2 [draft-josefsson-pppext-eap-tls-eap-07.txt]
	    [draft-kamath-pppext-eap-mschapv2-00.txt]
	    (PEAP version 0, 1, and parts of 2; only 0 and 1 are enabled by
	    default; tested with FreeRADIUS, Microsoft IAS, and Funk Odyssey)
	  - new configuration file options: eap, identity, password, ca_cert,
	    client_cert, privatekey, private_key_passwd
	  - Xsupplicant is not required anymore, but it can be used by
	    disabling the internal IEEE 802.1X Supplicant with -e command line
	    option
	  - this code is not included in the default build; Makefile need to
	    be edited for this (uncomment lines for selected functionality)
	  - EAP-TLS and EAP-PEAP require openssl libraries
	* use module prefix in debug messages (WPA, EAP, EAP-TLS, ..)
	* added support for non-WPA IEEE 802.1X mode with dynamic WEP keys
	  (i.e., complete IEEE 802.1X/EAP authentication and use IEEE 802.1X
	   EAPOL-Key frames instead of WPA key handshakes)
	* added support for IEEE 802.11i/RSN (WPA2)
	  - improved PTK Key Handshake
	  - PMKSA caching, pre-authentication
	* fixed wpa_supplicant to ignore possible extra data after WPA
	  EAPOL-Key packets (this fixes 'Invalid EAPOL-Key MIC when using
	  TPTK' error from message 3 of 4-Way Handshake in case the AP
	  includes extra data after the EAPOL-Key)
	* added interface for external programs (frontends) to control
	  wpa_supplicant
	  - CLI example (wpa_cli) with interactive mode and command line
	    mode
	  - replaced SIGUSR1 status/statistics with the new control interface
	* made some feature compile time configurable
	  - .config file for make
	  - driver interfaces (hostap, hermes, ..)
	  - EAPOL/EAP functions

* Sun Feb 15 2004 - v0.2.0
	* Initial version of wpa_supplicant
